local Heatsink = LibStub("AceAddon-3.0"):GetAddon("Heatsink", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Heatsink")

local STRING_SCHOOL_FIRE = _G.STRING_SCHOOL_FIRE
local STRING_SCHOOL_SHADOW = _G.STRING_SCHOOL_SHADOW
local STRING_SCHOOL_FROST = _G.STRING_SCHOOL_FROST
local STRING_SCHOOL_HOLY = _G.STRING_SCHOOL_HOLY
local STRING_SCHOOL_NATURE = _G.STRING_SCHOOL_NATURE
local STRING_SCHOOL_ARCANE = _G.STRING_SCHOOL_ARCANE
local STRING_SCHOOL_PHYSICAL = _G.STRING_SCHOOL_PHYSICAL
local GetSpellInfo = _G.GetSpellInfo
local pairs = _G.pairs

local slots = {	"Trinket0Slot", 
		"Trinket1Slot",
		"Finger0Slot",
		"Finger1Slot",
		"HeadSlot"
	}

local spellreplace = {
	[(GetSpellInfo(1499))] = L["Traps"], -- 1499 Freezing Trap
	[(GetSpellInfo(13795))] = L["Traps"], -- 13795 Immolation Trap
	[(GetSpellInfo(13809))] = L["Traps"], -- 13909 Immolation Trap
	[(GetSpellInfo(13813))] = L["Traps"], -- 13813 Explosive Trap
	[(GetSpellInfo(34600))] = L["Traps"], -- 34600 Snake Trap
	[(GetSpellInfo(8042))] = L["Shocks"], -- 8042 Earth Shock
	[(GetSpellInfo(8056))] = L["Shocks"], -- 8056 Frost Shock
	[(GetSpellInfo(8050))] = L["Shocks"], -- 8050 Flame Shock
	[(GetSpellInfo(53408))] = L["Judgement"], -- Judgement of Wisdom
	[(GetSpellInfo(20271))] = L["Judgement"], -- Judgement of Light
	[(GetSpellInfo(53407))] = L["Judgement"], -- Judgement of Justice
	[(GetSpellInfo(16979))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Bear, 49377 Feral Charge (Talent)
	[(GetSpellInfo(49376))] = (GetSpellInfo(49377)), -- 16979 Feral Charge - Cat,  49377 Feral Charge (Talent)
}

local itemreplace = {
	[L["Mana Jade"]] = L["Stones"],
	[L["Mana Ruby"]] = L["Stones"],
	[L["Mana Citrine"]] = L["Stones"],
	[L["Mana Agate"]] = L["Stones"],
	[L["Mana Emerald"]] = L["Stones"],
	[L["Healthstone$"]] = L["Stones"],
	[L["Potion"]] = L["Potions"],
	[L["Blue Ogre Brew Special"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew Special"]] = L["Potions"],  --Ogri'la
	[L["Blue Ogre Brew"]]= L["Potions"],  --Ogri'la
	[L["Red Ogre Brew"]] = L["Potions"],  --Ogri'la
	[L["Bottled Nethergon Energy"]] = L["Potions"],  --Tempest Keep
	[L["Bottled Nethergon Vapor"]] = L["Potions"],   --Tempest Keep
	[L["Cenarion Mana Salve"]] = L["Potions"],   --Cenarion Expedition
	[L["Cenarion Healing Salve"]] = L["Potions"],   --enarion Expedition
	[L["Major Healing Draught"]] = L["Potions"],   --PvP
	[L["Major Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Mana Draught"]] = L["Potions"],   --PvP
	[L["Superior Healing Draught"]] = L["Potions"],   --PvP
}

local baseline = {
	["WARLOCK"] = {
		[(GetSpellInfo(686))] = STRING_SCHOOL_SHADOW, -- 686 Shadow Bolt 
		[(GetSpellInfo(5676))] = STRING_SCHOOL_FIRE, -- 5676 Searing Pain
	},
	["MAGE"] = {
		[(GetSpellInfo(5143))] = STRING_SCHOOL_ARCANE, -- 5343 Arcane Missiles 
		[(GetSpellInfo(133))] = STRING_SCHOOL_FIRE,  -- 133 Fireball
		[(GetSpellInfo(116))] = STRING_SCHOOL_FROST, -- 116 Frostbolt
	},
	["DRUID"] = {
		[(GetSpellInfo(5185))] = STRING_SCHOOL_NATURE, -- 5185 Healing Touch
	},
	["SHAMAN"] = {
		[(GetSpellInfo(3738))] = STRING_SCHOOL_PHYSICAL, -- 3738 Wrath of Air Totem 
		[(GetSpellInfo(8227))] = STRING_SCHOOL_FIRE, -- 8227 Flametongue Totem
		[(GetSpellInfo(5394))] = STRING_SCHOOL_FROST, -- 5394 Healing Stream Totem
		[(GetSpellInfo(403))] = STRING_SCHOOL_NATURE, -- 403 Lightning Bolt
	},
	["PRIEST"] = {
		[(GetSpellInfo(589))] = STRING_SCHOOL_SHADOW, -- 589 Shadow Word: Pain
		[(GetSpellInfo(585))] = STRING_SCHOOL_HOLY, --585 Smite
	},
	["PALADIN"] = {
		[(GetSpellInfo(635))] = STRING_SCHOOL_HOLY, -- 635 Holy Light
	},
}

local school = {
	["WARLOCK"] = {
		[(GetSpellInfo(6229))] = STRING_SCHOOL_SHADOW, -- 6229 Shadow Ward
		[(GetSpellInfo(5484))] = STRING_SCHOOL_SHADOW, -- 5484 Howl of Terror
		[(GetSpellInfo(17877))] = STRING_SCHOOL_SHADOW, -- 17877 Shadowburn
		[(GetSpellInfo(18540))] = STRING_SCHOOL_SHADOW, -- 18540 Ritual of Doom
		[(GetSpellInfo(603))] = STRING_SCHOOL_SHADOW, -- 603 Curse of Doom
		[(GetSpellInfo(698))] = STRING_SCHOOL_SHADOW, -- 698 Ritual of Summoning
		[(GetSpellInfo(29893))] = STRING_SCHOOL_SHADOW, -- 29893 Ritual of Souls
		[(GetSpellInfo(6789))] = STRING_SCHOOL_SHADOW, -- 6789 Death Coil
		[(GetSpellInfo(29858))] = STRING_SCHOOL_SHADOW, -- 29858 Soulshatter
		[(GetSpellInfo(18708))] = STRING_SCHOOL_SHADOW, -- 18708 Fel Domination
		[(GetSpellInfo(48181))] = STRING_SCHOOL_SHADOW, -- 48181 Haunt
		[(GetSpellInfo(48020))] = STRING_SCHOOL_SHADOW, -- 48020 Demonic Circle: Teleport
		[(GetSpellInfo(48181))] = STRING_SCHOOL_SHADOW, -- 48181 Haunt 
		[(GetSpellInfo(47897))] = STRING_SCHOOL_SHADOW, -- 47897 Shadowflame
		[(GetSpellInfo(17962))] = STRING_SCHOOL_FIRE, -- 17962 Conflagrate
		[(GetSpellInfo(1122))] = STRING_SCHOOL_FIRE, -- 1122 Inferno
		[(GetSpellInfo(50796))] = STRING_SCHOOL_FIRE, -- 50796 Chaos Bolt
	},
	["MAGE"] = {
		[(GetSpellInfo(122))] = STRING_SCHOOL_FROST, -- 122 Frost Nova
		[(GetSpellInfo(120))] = STRING_SCHOOL_FROST, -- 120 Cone of Cold
		[(GetSpellInfo(6143))] = STRING_SCHOOL_FROST, -- 6143 Frost Ward
		[(GetSpellInfo(11426))] = STRING_SCHOOL_FROST, -- 11426 Ice Barrier
		[(GetSpellInfo(45438))] = STRING_SCHOOL_FROST, -- 45438 Ice Block
		[(GetSpellInfo(31687))] = STRING_SCHOOL_FROST, -- 31687 Summon Water Elemental
		[(GetSpellInfo(31661))] = STRING_SCHOOL_FIRE, -- 31661 Dragon's Breath
		[(GetSpellInfo(543))] = STRING_SCHOOL_FIRE, -- 543 Fire Ward
		[(GetSpellInfo(2136))] = STRING_SCHOOL_FIRE, -- 2136 Fire Blast
		[(GetSpellInfo(1831))] = STRING_SCHOOL_FIRE, -- 1831 Blast Wave
		[(GetSpellInfo(10059))] = STRING_SCHOOL_ARCANE, -- 10059 Portal: Stormwind
		[(GetSpellInfo(11416))] = STRING_SCHOOL_ARCANE, -- 11416 Portal: Ironforge
		[(GetSpellInfo(11419))] = STRING_SCHOOL_ARCANE, -- 11419 Portal: Darnassus
		[(GetSpellInfo(32266))] = STRING_SCHOOL_ARCANE, -- 32266 Portal: Exodar
		[(GetSpellInfo(11417))] = STRING_SCHOOL_ARCANE, -- 11417 Portal: Orgrimmar
		[(GetSpellInfo(32267))] = STRING_SCHOOL_ARCANE, -- 32267 Portal: Silvermoon
		[(GetSpellInfo(11420))] = STRING_SCHOOL_ARCANE, -- 11420 Portal: Thunder Bluff
		[(GetSpellInfo(11418))] = STRING_SCHOOL_ARCANE, -- 11418 Portal: Undercity
		[(GetSpellInfo(33691))] = STRING_SCHOOL_ARCANE, -- 33691 Portal: Shattrath
		[(GetSpellInfo(1953))] = STRING_SCHOOL_ARCANE, -- 1953 Blink
		[(GetSpellInfo(2139))] = STRING_SCHOOL_ARCANE, -- 2139 Counterspell
		[(GetSpellInfo(12051))] = STRING_SCHOOL_ARCANE, -- 12051 Evocation
		[(GetSpellInfo(12042))] = STRING_SCHOOL_ARCANE, -- 12042 Arcane Power
		[(GetSpellInfo(12043))] = STRING_SCHOOL_ARCANE, -- 12043 Presence of Mind
		[(GetSpellInfo(66))] = STRING_SCHOOL_ARCANE, -- 66 Invisibility

	},
	["DRUID"] = {
		[(GetSpellInfo(29166))] = STRING_SCHOOL_NATURE, -- 29166 Innervate
		[(GetSpellInfo(20484))] = STRING_SCHOOL_NATURE, -- 20484 Rebirth
		[(GetSpellInfo(16857))] = STRING_SCHOOL_NATURE, -- 16857 Faerie Fire (Feral)
		[(GetSpellInfo(740))] = STRING_SCHOOL_NATURE, -- 740 Tranquility
		[(GetSpellInfo(22812))] = STRING_SCHOOL_NATURE,  -- 22812 Barkskin
		[(GetSpellInfo(16689))] = STRING_SCHOOL_NATURE, -- 16689 Nature's Grasp
		[(GetSpellInfo(16914))] = STRING_SCHOOL_NATURE, -- 16914 Hurricane
	},
	["SHAMAN"] = {
		[(GetSpellInfo(16188))] = STRING_SCHOOL_PHYSICAL, -- 16188 Nature's Swiftness
		[(GetSpellInfo(30823))] = STRING_SCHOOL_PHYSICAL, -- 30823 Shamanistic Rage
		[(GetSpellInfo(17364))] = STRING_SCHOOL_PHYSICAL, -- 17364 Stormstrike
		[(GetSpellInfo(2894))] = STRING_SCHOOL_FIRE, -- 2894 Fire Elemental Totem
		[(GetSpellInfo(1535))] = STRING_SCHOOL_FIRE, -- 1535 Fire Nova Totem
		[(GetSpellInfo(8050))] = STRING_SCHOOL_FIRE, -- 8050 Flame Shock
		[(GetSpellInfo(8056))] = STRING_SCHOOL_FROST, -- 8056 Frost Shock
		[(GetSpellInfo(16190))] = STRING_SCHOOL_FROST, -- 16190 Mana Tide Totem
		[(GetSpellInfo(2062))] = STRING_SCHOOL_NATURE, -- 2062 Earth Elemental Totem
		[(GetSpellInfo(8042))] = STRING_SCHOOL_NATURE, -- 8042 Earth Shock
		[(GetSpellInfo(556))] = STRING_SCHOOL_NATURE, -- 556 Astral Recall
		[(GetSpellInfo(2825))] = STRING_SCHOOL_NATURE, -- 2825 Bloodlust
		[(GetSpellInfo(2484))] = STRING_SCHOOL_NATURE, -- 2484 Earthbind Totem
		[(GetSpellInfo(16166))] = STRING_SCHOOL_NATURE, -- 16166 Elemental Mastery
		[(GetSpellInfo(32182))] = STRING_SCHOOL_NATURE, -- 32182 Heroism
		[(GetSpellInfo(8177))] = STRING_SCHOOL_NATURE, -- 8177 Grounding Totem
		[(GetSpellInfo(20608))] = STRING_SCHOOL_NATURE, -- 20608 Reincarnation
		[(GetSpellInfo(5730))] = STRING_SCHOOL_NATURE, -- 5730 Stoneclaw Totem
		[(GetSpellInfo(421))] = STRING_SCHOOL_NATURE, -- 421 Chain Lightning
	},
	["PRIEST"] = {
		[(GetSpellInfo(586))] = STRING_SCHOOL_SHADOW, -- 586 Fade
		[(GetSpellInfo(8092))] = STRING_SCHOOL_SHADOW, -- 8092 Mind Blast
		[(GetSpellInfo(32379))] = STRING_SCHOOL_SHADOW, -- 32379 Shadow Word: Death
		[(GetSpellInfo(15407))] = STRING_SCHOOL_SHADOW, -- 15407 Mind Flay
		[(GetSpellInfo(34433))] = STRING_SCHOOL_SHADOW, -- 34433 Shadowfiend
		[(GetSpellInfo(19238))] = STRING_SCHOOL_HOLY, -- 19238 Desperate Prayer
		[(GetSpellInfo(15263))] = STRING_SCHOOL_HOLY, -- 15263 Holy Fire
		[(GetSpellInfo(27870))] = STRING_SCHOOL_HOLY, -- 27870 Lightwell
		[(GetSpellInfo(33076))] = STRING_SCHOOL_HOLY, -- 33076 Prayer of Mending
		[(GetSpellInfo(34863))] = STRING_SCHOOL_HOLY, -- 34863 Circle of Healing
		[(GetSpellInfo(47540))] = STRING_SCHOOL_HOLY, -- 47540 Penance
		[(GetSpellInfo(64843))] = STRING_SCHOOL_HOLY, -- 64843 Divine Hymn
		[(GetSpellInfo(64901))] = STRING_SCHOOL_HOLY, -- 64901 Hymn of Hope
	},
	["PALADIN"] = {
		[(GetSpellInfo(20473))] = STRING_SCHOOL_HOLY, -- 20473 Holy Shock
		[(GetSpellInfo(642))] = STRING_SCHOOL_HOLY, -- 642 Divine Shield
		[(GetSpellInfo(498))] = STRING_SCHOOL_HOLY, -- 498 Divine Protection
		[(GetSpellInfo(31842))] = STRING_SCHOOL_HOLY, -- 31842 Divine Illumination
		[(GetSpellInfo(20216))] = STRING_SCHOOL_HOLY, -- 20216 Divine Favor
		[(GetSpellInfo(26573))] = STRING_SCHOOL_HOLY, -- 26573 Consecration
		[(GetSpellInfo(633))] = STRING_SCHOOL_HOLY, -- 633 Lay on Hands
		[(GetSpellInfo(2812))] = STRING_SCHOOL_HOLY, -- 2812 Holy Wrath
		[(GetSpellInfo(24275))] = STRING_SCHOOL_HOLY, -- 24275 Hammer of Wrath
		[(GetSpellInfo(879))] = STRING_SCHOOL_HOLY, -- 879 Exorcism
		[(GetSpellInfo(10326))] = STRING_SCHOOL_HOLY, -- 10326 Turn Evil
		[(GetSpellInfo(31789))] = STRING_SCHOOL_HOLY, -- 31789 Righteous Defense
		[(GetSpellInfo(31884))] = STRING_SCHOOL_HOLY, -- 31884 Avenging Wrath
		[(GetSpellInfo(20271))] = STRING_SCHOOL_HOLY, -- 20271 Judgement of Light
		[(GetSpellInfo(2812))] = STRING_SCHOOL_HOLY, -- 2812 Holy Wrath
		[(GetSpellInfo(853))] = STRING_SCHOOL_HOLY, -- 853 Hammer of Justice
		[(GetSpellInfo(19752))] = STRING_SCHOOL_HOLY, -- 19752 Divine Intervention
	},
}

Heatsink.slots = Heatsink.slots or {}
for k,v in pairs(slots) do
	Heatsink.slots[k] = v
end

Heatsink.spellreplace = Heatsink.spellreplace or {}
for k,v in pairs(spellreplace) do
	Heatsink.spellreplace[k] = v
end

Heatsink.itemreplace = Heatsink.itemreplace or {}
for k,v in pairs(itemreplace) do
	Heatsink.itemreplace[k] = v
end

Heatsink.baseline = Heatsink.baseline or {}
for k,v in pairs(baseline) do
	Heatsink.baseline[k] = v
end
  
Heatsink.school = Heatsink.school or {}
for k,v in pairs(school) do
	Heatsink.school[k] = v
end
